package com.iconplus.smartproc.model.entity;

import com.iconplus.smartproc.helper.base.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import javax.persistence.*;
import java.sql.Date;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@Entity
@Table(name = "drp")
public class Drp extends BaseEntity {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name = "tahun")
    private Integer tahun;

    @Column(name = "approve_status")
    private String approveStatus;

    @Column(name = "approve_date")
    private Date approveDate;

    @Column(name = "vp_approve_date")
    private Date vpApproveDate;

    @Column(name = "komite_approve_date")
    private Date komiteApproveDate;

    @Column(name = "direktur_approve_date")
    private Date direkturApproveDate;

    @Column(name = "is_print")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isPrint;

    @Column(name = "print_date")
    private Date printDate;

    @Column(name = "is_active")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isActive;

    @Column(name = "is_delete")
    @Type(type = "org.hibernate.type.NumericBooleanType")
    private Boolean isDelete;
}
