package com.iconplus.smartproc.repository;

import com.iconplus.smartproc.model.entity.DrpApprovalHistory;
import com.iconplus.smartproc.model.projection.DrpApprovalHistoryView;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DrpApprovalHistoryRepository extends JpaRepository<DrpApprovalHistory, Long> {

    @Query(value = "SELECT dah.status as status, " +
            "dah.date as date, " +
            "da.catatan as catatan, " +
            "u.nama as nama, " +
            "j.jabatan as jabatan " +
            "FROM DrpApprovalHistory dah " +
            "JOIN DrpApproval da ON da.id = dah.drpApprovalId " +
            "JOIN Users u ON u.id = da.approverUserId " +
            "JOIN Jabatan j ON j.id = u.jabatanId " +
            "WHERE da.drpId = :drpId " +
            "ORDER BY dah.timeCreated desc")
    List<DrpApprovalHistoryView> getRiwayatApprovalByDrpId(Long drpId);

}
